unit ColourForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus;

type
  TfColourForm = class(TForm)
    PopupMenu1: TPopupMenu;
    Float1: TMenuItem;
    Dock1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormStartDock(Sender: TObject; var DragObject: TDragDockObject);
    procedure Float1Click(Sender: TObject);
    procedure Dock1Click(Sender: TObject);
  private
    PredockedLocation: TRect;
    procedure SetPredockedLocation;
    { Private declarations }
  public
    DefaultDockLocation: TWinControl;
    { Public declarations }
  end;

var
  fColourForm: TfColourForm;

implementation

{$R *.dfm}

uses DockingUtils;

procedure TfColourForm.Dock1Click(Sender: TObject);
begin
  SetPredockedLocation;
  ManualDock(DefaultDockLocation)
end;

procedure TfColourForm.SetPredockedLocation;
begin
  if Floating then
    PredockedLocation := Rect(Left, Top, Left + Width, Top + Height);
end;

procedure TfColourForm.Float1Click(Sender: TObject);
begin
  ManualFloat(PredockedLocation);
end;

procedure TfColourForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfColourForm.FormCreate(Sender: TObject);
begin
  Color := Random($FFFFFF);
  Caption := ColorToString(Color)
end;

procedure TfColourForm.FormStartDock(Sender: TObject;
  var DragObject: TDragDockObject);
begin
  DragObject := TTransparentDragDockObject.Create(Self);
  SetPredockedLocation;
end;

end.
