unit ElementRenderer;

interface

uses
  element, Vcl.Graphics, System.Types;

procedure DrawPeriodicTableCellBackground(HasElement, IsSelected: boolean; Canvas: TCanvas; Rect: TRect);
procedure DrawPeriodicTableCellContents(e: IElement; Canvas: TCanvas; Rect: TRect);

implementation

uses
  System.SysUtils, Math;

procedure DrawPeriodicTableCellBackground(HasElement,
  IsSelected: boolean; Canvas: TCanvas; Rect: TRect);
begin
  if HasElement then
  begin
    if IsSelected then
      Canvas.Brush.Color := clHighlight
    else
      Canvas.Brush.Color := clMoneyGreen
  end
  else
    Canvas.Brush.Color := clWindow;
  Canvas.FillRect(Rect);
end;

procedure DrawPeriodicTableCellContents(e: IElement;
  Canvas: TCanvas; Rect: TRect);
var
  TextX, TextY : integer;
  TextWidth, TextHeight : integer;
begin
  Canvas.Font.Size := 7;
  Canvas.Font.Style := [];
  Canvas.TextOut(Rect.Left + 2, Rect.Top + 2, IntToStr(e.Number));

  Canvas.Font.Size := 12;
  Canvas.Font.Style := [fsBold];

  TextWidth := Canvas.TextWidth(e.Symbol);
  TextHeight := Canvas.TextHeight(e.Symbol);

  TextX := (Rect.Width - TextWidth) div 2 + Rect.Left;
  TextY := 2 * (Rect.Height - TextHeight) div 3 + Rect.Top;

  Canvas.TextOut(TextX, TextY, e.Symbol);
end;

end.
